﻿using System.Drawing;
using System.Drawing.Drawing2D;

using DevExpress.XtraEditors;
using DevExpress.XtraGrid.Views.Base;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.cardView.OptionsBehavior.AutoPopulateColumns = true;

            this.gridControl.DataSource = new nwindDataSetTableAdapters.ProductsTableAdapter().GetData();

            this.cardView.CustomDrawCardFieldValue += cardView_CustomDrawCardFieldValue;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 카드 뷰 카드 필드 값 커스텀 그리기 - cardView_CustomDrawCardFieldValue(sender, e)

        /// <summary>
        /// 카드 뷰 카드 필드 값 커스텀 그리기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void cardView_CustomDrawCardFieldValue(object sender, RowCellCustomDrawEventArgs e)
        {
            if(e.Column.FieldName != "UnitPrice")
            {
                return;
            }

            Color color1 = Color.FromArgb(40, 170, 225);
            Color color2 = Color.FromArgb(35, 80 , 160);

            Brush brush = e.Cache.GetGradientBrush(e.Bounds, color1, color2, LinearGradientMode.Horizontal);

            e.Appearance.ForeColor = Color.White;
            e.Appearance.Font      = e.Cache.GetFont(e.Appearance.Font, FontStyle.Bold);

            e.Cache.FillRectangle(brush, e.Bounds);

            e.Appearance.DrawString(e.Cache, e.DisplayText, e.Bounds);

            e.Handled = true;
        }

        #endregion
    }
}